<?php
/*
  $Id: slimCheckout.php
  $Loc: catalog/includes/hooks/shop/system/

  Slim Checkout 1.7
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021, Rainer Schmied
  All rights reserved.

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_shop_system__28_slimCheckout {

  public $version = '1.7';

  public function listen_startApplication() {

    if ( defined('MODULE_STORE_SLIM_CHECKOUT_STATUS') && MODULE_STORE_SLIM_CHECKOUT_STATUS == 'True' ) {

      function get_dynamic_parent() {
        return TEMPLATE_SELECTION .'_template';
      }
      class_alias(get_dynamic_parent(), 'DynamicParent');

      $title = $GLOBALS['Template']->get_title();
      $GLOBALS['Template'] = new Template(new class('slim_checkout') extends DynamicParent {

        public function getGridColumnWidth() {
          if ( in_array(basename(Request::get_page()), explode(';', MODULE_STORE_SLIM_CHECKOUT_BOXES)) ) { // define columns width if side columns are hidden
            return (12 - MODULE_STORE_SLIM_CHECKOUT_CONTENT_WIDTH) / 2;
          } else {
            return (12 - BOOTSTRAP_CONTENT) / 2;
          }
        }

      });
      $GLOBALS['Template']->set_title($title);

      // remove modules
      $GLOBALS['hooks']->set('getContentModules', 'disable_checkout', function ($parameters) {

        switch ($parameters['group']) {
          case 'navigation':
            if (in_array(basename(Request::get_page()), explode(';', MODULE_STORE_SLIM_CHECKOUT_NAVBAR))) {
              $parameters['modules'] = [];
            }
            break;
          case 'header':
            if (in_array(basename(Request::get_page()), explode(';', MODULE_STORE_SLIM_CHECKOUT_HEADER))) {
              $parameters['modules'] = explode(',', MODULE_STORE_SLIM_CHECKOUT_EXCLUDE);
            }
            break;
          case 'footer':
            if (in_array(basename(Request::get_page()), explode(';', MODULE_STORE_SLIM_CHECKOUT_FOOTER))) {
              $parameters['modules'] = [];
            }
            break;
          case 'footer_suffix':
            if (in_array(basename(Request::get_page()), explode(';', MODULE_STORE_SLIM_CHECKOUT_FOOTER_SUFFIX))) {
              $parameters['modules'] = [];
            }
            break;
        }
      });

    }

  }

}
