<?php
/*
  $Id$
  Slim Checkout 1.7
  by @raiwa Rainer Schmied
  info@oscaddons.com
  www.oscaddons.com

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2021 Rainer Schmied

  Released under the GNU General Public License
*/

  class st_slim_checkout extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_STORE_SLIM_CHECKOUT_';

    public function __construct() {
      parent::__construct(__FILE__);

    }

    function execute() {

    }

    protected function get_parameters() {
      return [
        'MODULE_STORE_SLIM_CHECKOUT_VERSION' => [
          'title' => 'Current Version',
          'value' => '1.7',
          'desc' => 'Version info. It is read only',
          'set_func' => 'st_slim_checkout::readonly(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_STATUS' => [
          'title' => 'Enable Slim Checkout',
          'value' => 'True',
          'desc' => 'Enable this module?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_STORE_SLIM_CHECKOUT_NAVBAR' => [
          'title' => 'Hide Navbar',
          'value' => '',
          'desc' => 'Hide the Navabar module on Checkout Pages?',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_HEADER' => [
          'title' => 'Hide Header Area Modules',
          'value' => 'checkout_payment.php;checkout_payment_address.php;'
                   . 'checkout_shipping.php;checkout_shipping_address.php;'
                   . 'checkout_confirmation.php',
          'desc' => 'Hide the modules in the Header Area on Checkout Pages?',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_BOXES' => [
          'title' => 'Hide Side Column Boxes',
          'value' => 'checkout_payment.php;checkout_payment_address.php;'
                   . 'checkout_shipping.php;checkout_shipping_address.php;'
                   . 'checkout_confirmation.php',
          'desc' => 'Hide the Side Column Boxes on Checkout Pages?',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_FOOTER' => [
          'title' => 'Hide Footer Modules',
          'value' => '',
          'desc' => 'Hide the Footer Modules on Checkout Pages?',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_FOOTER_SUFFIX' => [
          'title' => 'Hide Footer Suffix Modules',
          'value' => '',
          'desc' => 'Hide the Footer Suffix Modules on Checkout Pages?',
          'use_func' => 'page_selection::_show_pages',
          'set_func' => 'page_selection::_edit_pages(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_EXCLUDE' => [
          'title' => 'Exclude Header Modules',
          'value' => 'cm_header_logo',
          'desc' => 'List of modules to show always in the header area, even the header module area is hidden?<br>Comma separated list.<br>Only for header modules: \"cm_header_...\"',
          'set_func' => 'st_slim_checkout::_textarea(',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '8',
          'desc' => 'Content width if side columns are hidden.<br>Should be a pair value between the normal main content width (default = 8) => no content stretch, and the max width (12) => stretch content to full width.<br>Usual values: 8, 10 or 12',
        ],
        'MODULE_STORE_SLIM_CHECKOUT_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '0',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

    public static function readonly($value) {
      return $value;
    }

    public static function _textarea($text, $key = '') {
      $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
      $textarea = new Textarea($name, ['style' => 'font: inherit;']);
      $textarea->set('cols', 35)->set('rows', 5);
      if (!Text::is_empty($text)) {
        $textarea->set_text($text);
      }
      return $textarea;
    }

  }
